unit hiHelp;

interface

uses
  Windows, Kol, Share;  

type
  
  ThiHelp = class
    private

    public
      _prop_HelpFile: string;
      _prop_Topic: string;
      _prop_Font: string;
      _prop_mLeft: Integer;
      _prop_mTop: Integer;
      _prop_mRight: Integer;
      _prop_mBottom: Integer;
      _prop_TextColor: TColor;
      _prop_BgColor: TColor;
      

      _data_HelpFile: THI_Event;
      _data_Topic: THI_Event;
      _data_Text: THI_Event;
      _data_Handle: THI_Event;
      _data_X: THI_Event;
      _data_Y: THI_Event;
      
      procedure _work_doShowTopic(var _Data: TData; Index: Word);
      procedure _work_doPopup(var _Data: TData; Index: Word);  
      procedure _work_doTextColor(var _Data: TData; Index: Word);  
      procedure _work_doBgColor(var _Data: TData; Index: Word);  
  end;

implementation

procedure ThiHelp._work_doShowTopic(var _Data: TData; Index: Word);
var
  FN: string;
  T: string;
begin
  FN := ReadString(_Data, _data_HelpFile, _prop_HelpFile);
  T := ReadString(_Data, _data_Topic, _prop_Topic);
  if T <> '' then T := '::/' + T;
  HtmlHelpCommand(ReadInteger(_Data, _data_Handle, 0), FN + T, HH_DISPLAY_TOPIC, 0); 
end;

procedure ThiHelp._work_doPopup(var _Data: TData; Index: Word);
var
  HH: THHPopup;
  T: string;
  P: TPoint;
begin
  T := ReadString(_Data, _data_Text, '');
  if T = '' then Exit;

  P.x := ReadInteger(_Data, _data_X, 0);
  if P.x = 0 then GetCursorPos(P) else P.y := ReadInteger(_Data, _data_Y, 0);   
  
  with HH do
  begin
    cbStruct := SizeOf(THHPopup);
    idString := 0;
    pszText := PChar(T);
    pt := P;
    
    if _prop_TextColor = clDefault then
      clrForeground := $FFFFFFFF
    else
      clrForeground := _prop_TextColor;
    if _prop_BgColor = clDefault then
      clrBackground := $FFFFFFFF
    else
      clrBackground := _prop_BgColor;
    
    rcMargins.Left := _prop_mLeft;
    rcMargins.Top := _prop_mTop;
    rcMargins.Right := _prop_mRight;
    rcMargins.Bottom := _prop_mBottom;
    pszFont := PChar(_prop_Font);
  end;
  
  HtmlHelpCommand(ReadInteger(_Data, _data_Handle, 0), '', HH_DISPLAY_TEXT_POPUP, Longint(@HH));

end;

procedure ThiHelp._work_doTextColor(var _Data: TData; Index: Word);
begin
  _prop_TextColor := ToInteger(_Data);
end;

procedure ThiHelp._work_doBgColor(var _Data: TData; Index: Word);
begin
  _prop_BgColor := ToInteger(_Data);
end;

end.